import "Turbine.UI";
import "Turbine.UI.Lotro";
import "GlafriasPlugins.Pferdespielzeug";
import "GlafriasPlugins.Pferdespielzeug.Lib.Turbine.UI.Extensions";

import "GlafriasPlugins.Pferdespielzeug.VindarPatch";
import "GlafriasPlugins.Pferdespielzeug.ToggleWindow";

--import "GlafriasPlugins.Pferdespielzeug.DesktopIcon";
--Datei noch löschen

edgePadding = 50;
hudVisible=true; -- the actual HUD state is not exposed to Lua so we have to assume the HUD is visible when the plugin loads
sebisWindowVisible=true; -- used to retain the state of the window for when the HUD is toggled back on

function LoadSettings()

settings=PatchDataLoad( Turbine.DataScope.Character, "PferdespielzeugSettings");

	if ( type( settings ) ~= "table" ) then
		settings = { };
	end
	
	if ( not settings.ToggleVisible ) then
		settings.ToggleVisible = false;
	end
	
	if ( not settings.ToggleOpacity ) then
		settings.ToggleOpacity = 0.6;
	end
	
	if ( not settings.TWToggleOpacity ) then
		settings.TWToggleOpacity = 0.6;
	end
	
	if ( not settings.welcome ) then
		settings.welcome = false;
	end

	if ( not settings.positionX ) then		
		settings.positionX = ( Turbine.UI.Display.GetWidth() - mainWindow:GetWidth() - edgePadding);		
	end
	
	if ( not settings.positionY ) then	
		settings.positionY = ( Turbine.UI.Display.GetHeight() - mainWindow:GetHeight() - edgePadding * 1.5 );
	end
	
	if ( not settings.alwaysHide ) then
		settings.alwaysHide = false;
	end
	
	if ( not settings.activeCarousel ) then
		settings.activeCarousel = 0;
	end
	
	if ( not settings.petQS1 ) then
		settings.petQS1 = 0;
	end
	
	if ( not settings.petQS2 ) then
		settings.petQS2 = 1;
	end
	
	if ( not settings.petQS3 ) then
		settings.petQS3 = 2;
	end
	
	if ( not settings.petQS4 ) then
		settings.petQS4 = 3;
	end
	
	if ( not settings.petQS5 ) then
		settings.petQS5 = 4;
	end
	
	if ( not settings.petQS6 ) then
		settings.petQS6 = 5;
	end
	
	if ( not settings.petQS7 ) then
		settings.petQS7 = 6;
	end

	if ( not settings.cosmeticQS1 ) then
		settings.cosmeticQS1 = 0;
	end
	
	if ( not settings.cosmeticQS2 ) then
		settings.cosmeticQS2 = 1;
	end
	
	if ( not settings.cosmeticQS3 ) then
		settings.cosmeticQS3 = 2;
	end
	if ( not settings.cosmeticQS4 ) then
		settings.cosmeticQS4 = 3;
	end
	if ( not settings.cosmeticQS5 ) then
		settings.cosmeticQS5 = 4;
	end
	if ( not settings.cosmeticQS6 ) then
		settings.cosmeticQS6 = 5;
	end
	if ( not settings.cosmeticQS7 ) then
		settings.cosmeticQS7 = 6;
	end

	if ( not settings.customShortcuts ) then
		settings.customShortcuts = { };
		
		--[[Change "11" for whatever you want to set the maximum number of Custom Shortcuts 
		(you will need to delete the Settings file located at Documents\The Lord of the Rings Online\PluginData\AccountName\ServerName\CharacterName\PferdespielzeugSettings.plugindata
		and reload the plugin)]]
		
		for i = 0, 111 do 
			settings.customShortcuts[i] = { Type = "nil", Data = "" };
		end
	end
	
	if ( not settings.customQS1 ) then
		settings.customQS1 = 0;
	end
	
	if ( not settings.customQS2 ) then
		settings.customQS2 = 1;
	end
	
	if ( not settings.customQS3 ) then
		settings.customQS3 = 2;
	end
	if ( not settings.customQS4 ) then
		settings.customQS4 = 3;
	end
	if ( not settings.customQS5 ) then
		settings.customQS5 = 4;
	end
	if ( not settings.customQS6 ) then
		settings.customQS6 = 5;
	end
	if ( not settings.customQS7 ) then
		settings.customQS7 = 6;
	end
	
end

function SaveSettings()

	PatchDataSave( Turbine.DataScope.Character, "PferdespielzeugSettings", settings );

end


function TableCount(T)

	local count = 0
	for _ in pairs(T) do 
		count = count + 1 
	end
	return count

end




mainWindow = Turbine.UI.Extensions.Window();
mainWindow:SetSize( 300 , 235 );
mainWindow:SetText("Pferdespielzeug");
mainWindow:SetOpacity( 1 );
mainWindow:SetFadeSpeed( 1 );
mainWindow:SetVisible( false );

LoadSettings();


toggleWindowVisible=true; -- used to retain the state of the window for when the HUD is toggled back on
toggleWindow = GlafriasPlugins.Pferdespielzeug.ToggleWindow();
if (settings.TWToggleVisible == "yes") then
	toggleWindow:SetVisible( true );
else 
	toggleWindow:SetVisible( false );
end

toggleWindow.KeyDown=function(sender, args)

  if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then -- hide the window due to Escape
    toggleWindow:SetVisible( false );
	mainWindow:SetVisible( false );
  elseif ( args.Action == 268435635 ) then -- toggle HUD (the HUD action is not defined in the Turbine.UI.Lotro.Action enumeration although it should be)
    hudVisible=not hudVisible;
    if hudVisible then
      toggleWindow:SetVisible(sebisWindowVisible);
    else
      sebisWindowVisible=toggleWindow:IsVisible();
      toggleWindow:SetVisible(false);
	  mainWindow:SetVisible( false );
    end
  end
end

toggleWindow:SetWantsKeyEvents(true); -- enable keyevents (Actions) for this control


mainWindow:SetPosition(settings.positionX, settings.positionY);


leftWindow1 = Turbine.UI.Extensions.SimpleWindow();
leftWindow1:SetSize( 35 , 35 );
leftWindow1:SetParent( mainWindow );
leftWindow1:SetPosition( 20.5, 70 );
leftWindow1:SetOpacity( 0.25 );
leftWindow1:SetFadeSpeed( 0.5 );
leftWindow1:SetVisible( true );


leftWindow2 = Turbine.UI.Extensions.SimpleWindow();
leftWindow2:SetSize( 35 , 35 );
leftWindow2:SetParent( mainWindow );
leftWindow2:SetPosition( 90.5, 90 );
leftWindow2:SetOpacity( 0.25 );
leftWindow2:SetFadeSpeed( 0.5 );
leftWindow2:SetVisible( true );

leftWindow3 = Turbine.UI.Extensions.SimpleWindow();
leftWindow3:SetSize( 35 , 35 );
leftWindow3:SetParent( mainWindow );
leftWindow3:SetPosition( 90.5, 150 );
leftWindow3:SetOpacity( 0.25 );
leftWindow3:SetFadeSpeed( 0.5 );
leftWindow3:SetVisible( true );

centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 50 , 50 );
centerWindow:SetParent( mainWindow );
centerWindow:SetPosition( 125.5, 190 );
centerWindow:SetVisible( true );

rightWindow1 = Turbine.UI.Extensions.SimpleWindow();
rightWindow1:SetSize( 35 , 35 );
rightWindow1:SetParent( mainWindow );
rightWindow1:SetPosition( 160.5, 150 );
rightWindow1:SetOpacity( 0.25 );
rightWindow1:SetFadeSpeed( 0.5 );
rightWindow1:SetVisible( true );

rightWindow2 = Turbine.UI.Extensions.SimpleWindow();
rightWindow2:SetSize( 35 , 35 );
rightWindow2:SetParent( mainWindow );
rightWindow2:SetPosition( 160.5, 90 );
rightWindow2:SetOpacity( 0.25 );
rightWindow2:SetFadeSpeed( 0.5 );
rightWindow2:SetVisible( true );

rightWindow3 = Turbine.UI.Extensions.SimpleWindow();
rightWindow3:SetSize( 35 , 35 );
rightWindow3:SetParent( mainWindow );
rightWindow3:SetPosition( 220.5, 70 );
rightWindow3:SetOpacity( 0.25 );
rightWindow3:SetFadeSpeed( 0.5 );
rightWindow3:SetVisible( true );

releaseWindow = Turbine.UI.Extensions.SimpleWindow();
releaseWindow:SetSize( 20, 20 );
releaseWindow:SetParent( mainWindow );
releaseWindow:SetPosition( 125.5, 47 );
releaseWindow:SetOpacity( 0.25 );
releaseWindow:SetFadeSpeed( 0.5 );
releaseWindow:SetVisible( true );


releaseButtonLabel = Turbine.UI.Label();
releaseButtonLabel:SetParent(releaseWindow);
releaseButtonLabel:SetSize( 20, 20 );
releaseButtonLabel:SetBackground( "GlafriasPlugins/Pferdespielzeug/Resources/x.tga" );
releaseButtonLabel:SetMouseVisible(false);

releaseQSBack = Turbine.UI.Control();
releaseQSBack:SetParent( releaseWindow );
releaseQSBack:SetZOrder(-1);

releaseQS = Turbine.UI.Lotro.Quickslot();
releaseQS:SetParent(  releaseQSBack );
releaseQS:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/pferdespielzeug"));

releaseQS:SetSize( 14, 14 );
releaseQS:SetAllowDrop(false);

petData = { };

-- Pet Carousel: Adds your own codes here, that's all!

petData[0] = "0x7001BFFD"; -- Bree Starter Pony
petData[1] = "0x7001B4B9"; -- Bay Pony
petData[2] = "0x7001B4BE"; -- Blonde Sorrel Pony
petData[3] = "0x7001B4B2"; -- Bloodbay Pony
petData[4] = "0x7001B4BD"; -- Chestnut Pony
petData[5] = "0x7001B4C8"; -- Springfest Pony
petData[6] = "0x70020551"; -- Blue Roan Pony
petData[7] = "0x7001B4D2"; -- Lithe Festival Pony
petData[8] = "0x700216FA"; -- Pale Golden Summer Pony
petData[9] = "0x7001B4D7"; -- Harvestmath Pony
petData[10] = "0x7001B4BF"; -- Yule Festival Pony
petData[11] = "0x7001CF5E"; -- Liver Chestnut Pony
petData[12] = "0x7001B4D4"; -- Dark Chestnut Pony
petData[13] = "0x7001B4C8"; -- Tundra-Pony
petData[14] = "0x7001B4CF"; -- Ashen Pony
petData[15] = "0x7001B4DA"; -- Grey Pony
petData[16] = "0x7002054F"; -- Smoky Black Pony
petData[17] = "0x70022C6C"; -- Pony of the Grey Company
petData[18] = "0x7001E97B"; -- Dunedain War-Pony
petData[19] = "0x7001B4AA"; -- Mahogany Bay Pony
petData[20] = "0x7001E97F"; -- Galadhrim War-Pony
petData[21] = "0x7001E8EF"; -- Sable Harvestmath Pony
petData[22] = "0x7001B4D8"; -- Bree Pony
petData[23] = "0x70022C66"; -- Algraig Pony
petData[24] = "0x7001CEA9"; -- Dusky Nimblefoot Goat
petData[25] = "0x7001B4B3"; -- Tame Redhorn Goat 
petData[26] = "0x7001B4C6"; -- Nimble Redhorn-Goat
petData[27] = "0x7001E97C"; -- Nimble Black Goat
petData[28] = "0x7001E97E"; -- Wild Mountain Goat

petQS = { };

for i = 0, TableCount(petData)-1 do

	petQS[i] = Turbine.UI.Lotro.Quickslot();
	petQS[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, petData[i] ) );

end

cosmeticPetData = { }; 

-- Cosmetic Pet Carousel: Adds your own codes here, that's all!

cosmeticPetData[0] = "0x7001BFFE"; -- Bree-Starter Horse
cosmeticPetData[1] = "0x7001B4B7"; -- Bay Horse
cosmeticPetData[2] = "0x7001B4C9"; -- Blonde Sorrel Horse
cosmeticPetData[3] = "0x7001B4B0"; -- Bloodbay Horse
cosmeticPetData[4] = "0x7001B4C5"; -- Chestnut Horse
cosmeticPetData[5] = "0x7001B4A8"; -- Springfest Horse
cosmeticPetData[6] = "0x70020550"; -- Blue Roan Horse
cosmeticPetData[7] = "0x7001B4C7"; -- Lithe Festival Horse
cosmeticPetData[8] = "0x700216F9"; -- Pale Golden Summer Horse
cosmeticPetData[9] = "0x7001B4C0"; -- Harvestmath Horse
cosmeticPetData[10] = "0x7001B4CD"; -- Yule Festival Horse
cosmeticPetData[11] = "0x7001E8EE"; -- Yule Festival Snow Horse
cosmeticPetData[12] = "0x7001CF5D"; -- Liver Chestnut Horse
cosmeticPetData[13] = "0x7001B4AC"; -- Dark Chestnut Horse
cosmeticPetData[14] = "0x7001B4D3"; -- Tundra-Horse
cosmeticPetData[15] = "0x7001B4C4"; -- Ashen Horse
cosmeticPetData[16] = "0x7001B4D9"; -- Grey Horse
cosmeticPetData[17] = "0x7001B4D0"; -- Galadhrim Horse
cosmeticPetData[18] = "0x7002054D"; -- Smoky Black Horse
cosmeticPetData[19] = "0x70022C61"; -- Horse of the Grey Company
cosmeticPetData[20] = "0x7001E97D"; -- Dunedain War-Horse
cosmeticPetData[21] = "0x7001B4B1"; -- Mahogany Bay Horse
cosmeticPetData[22] = "0x7001E980"; -- Galadhrim War-Horse
cosmeticPetData[23] = "0x7001E8ED"; -- Sable Harvestmath Horse
cosmeticPetData[24] = "0x7001B4C1"; -- Bree Horse
cosmeticPetData[25] = "0x7001CEAA"; -- Dusky Nimblefoot Goat
cosmeticPetData[26] = "0x7001B4B4"; -- Tame Redhorn Goat 
cosmeticPetData[27] = "0x7001B4B8"; -- Nimble Redhorn-Goat
cosmeticPetData[28] = "0x7001E981"; -- Nimble Black Goat
cosmeticPetData[29] = "0x7001E97A"; -- Wild Mountain Goat

cosmeticPetQS = { };

for i = 0, TableCount(cosmeticPetData)-1 do

	cosmeticPetQS[i] = Turbine.UI.Lotro.Quickslot();
	cosmeticPetQS[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, cosmeticPetData[i] ) );

end

customPetQS = { };

for i = 0, TableCount(settings.customShortcuts)-1 do
	
	customPetQS[i] = Turbine.UI.Lotro.Quickslot();
	customPetQS[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.customShortcuts[i].Type, settings.customShortcuts[i].Data ) );

end

leftLabel1 = Turbine.UI.Label();
leftLabel1:SetParent(leftWindow1);
leftLabel1:SetPosition( 0, 0 );
leftLabel1:SetSize( 37.5, 41  );
leftLabel1:SetText( "" );
leftLabel1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
leftLabel1:SetZOrder(-1);
leftLabel1:SetMouseVisible(false);

leftQS1 = Turbine.UI.Lotro.Quickslot();
leftQS1:SetParent( leftWindow1 );
leftQS1:SetPosition( 0, 0 );
leftQS1:SetSize( 35, 35 );
leftQS1:SetUseOnRightClick(false);

leftLabel2 = Turbine.UI.Label();
leftLabel2:SetParent(leftWindow2);
leftLabel2:SetPosition( 0, 0 );
leftLabel2:SetSize( 37.5, 41  );
leftLabel2:SetText( "" );
leftLabel2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
leftLabel2:SetZOrder(-1);
leftLabel2:SetMouseVisible(false);

leftQS2 = Turbine.UI.Lotro.Quickslot();
leftQS2:SetParent( leftWindow2 );
leftQS2:SetPosition( 0, 0 );
leftQS2:SetSize( 35, 35 );
leftQS2:SetUseOnRightClick(false);

leftLabel3 = Turbine.UI.Label();
leftLabel3:SetParent(leftWindow3);
leftLabel3:SetPosition( 0, 0 );
leftLabel3:SetSize( 37.5, 41  );
leftLabel3:SetText( "" );
leftLabel3:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
leftLabel3:SetZOrder(-1);
leftLabel3:SetMouseVisible(false);

leftQS3 = Turbine.UI.Lotro.Quickslot();
leftQS3:SetParent( leftWindow3 );
leftQS3:SetPosition( 0, 0 );
leftQS3:SetSize( 35, 35 );
leftQS3:SetUseOnRightClick(false);



centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 37.5, 41  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS = Turbine.UI.Lotro.Quickslot();
centerQS:SetParent( centerWindow );
centerQS:SetPosition( 0, 0 );
centerQS:SetSize( 35, 35 );
centerQS:SetUseOnRightClick(false);

rightLabel1 = Turbine.UI.Label();
rightLabel1:SetParent(rightWindow1);
rightLabel1:SetPosition( 0, 0 );
rightLabel1:SetSize( 37.5, 41  );
rightLabel1:SetText( "" );
rightLabel1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
rightLabel1:SetZOrder(-1);
rightLabel1:SetMouseVisible(false);

rightQS1 = Turbine.UI.Lotro.Quickslot();
rightQS1:SetParent( rightWindow1);
rightQS1:SetPosition( 0, 0 );
rightQS1:SetSize( 35, 35 );
rightQS1:SetUseOnRightClick(false);


rightLabel2 = Turbine.UI.Label();
rightLabel2:SetParent(rightWindow2);
rightLabel2:SetPosition( 0, 0 );
rightLabel2:SetSize( 37.5, 41  );
rightLabel2:SetText( "" );
rightLabel2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
rightLabel2:SetZOrder(-1);
rightLabel2:SetMouseVisible(false);

rightQS2 = Turbine.UI.Lotro.Quickslot();
rightQS2:SetParent(rightWindow2);
rightQS2:SetPosition( 0, 0 );
rightQS2:SetSize( 35, 35 );
rightQS2:SetUseOnRightClick(false);


rightLabel3 = Turbine.UI.Label();
rightLabel3:SetParent(rightWindow3);
rightLabel3:SetPosition( 0, 0 );
rightLabel3:SetSize( 37.5, 41  );
rightLabel3:SetText( "123" );
rightLabel3:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
rightLabel3:SetZOrder(-1);
rightLabel3:SetMouseVisible(false);

rightQS3 = Turbine.UI.Lotro.Quickslot();
rightQS3:SetParent( rightWindow3);
rightQS3:SetPosition( 0, 0 );
rightQS3:SetSize( 35, 35 );
rightQS3:SetUseOnRightClick(false);



petQS1 = settings.petQS1;
petQS2 = settings.petQS2;
petQS3 = settings.petQS3;
petQS4 = settings.petQS4;
petQS5 = settings.petQS5;
petQS6 = settings.petQS6;
petQS7 = settings.petQS7;
cosmeticQS1 = settings.cosmeticQS1;
cosmeticQS2 = settings.cosmeticQS2;
cosmeticQS3 = settings.cosmeticQS3;
cosmeticQS4 = settings.cosmeticQS4;
cosmeticQS5 = settings.cosmeticQS5;
cosmeticQS6 = settings.cosmeticQS6;
cosmeticQS7 = settings.cosmeticQS7;
customQS1 = settings.customQS1;
customQS2 = settings.customQS2;
customQS3 = settings.customQS3;
customQS4 = settings.customQS4;
customQS5 = settings.customQS5;
customQS6 = settings.customQS6;
customQS7 = settings.customQS7;

activeCarousel = settings.activeCarousel;

function LoadShortcuts()

	if (activeCarousel == 0) then		
		
		leftQS1:SetShortcut(petQS[petQS1]:GetShortcut());
		leftQS1:SetAllowDrop(false);
		leftQS2:SetShortcut(petQS[petQS2]:GetShortcut());
		leftQS2:SetAllowDrop(false);
		leftQS3:SetShortcut(petQS[petQS3]:GetShortcut());
		leftQS3:SetAllowDrop(false);
		centerQS:SetShortcut(petQS[petQS4]:GetShortcut());
		centerQS:SetAllowDrop(false);
		rightQS1:SetShortcut(petQS[petQS5]:GetShortcut());
		rightQS1:SetAllowDrop(false);
		rightQS2:SetShortcut(petQS[petQS6]:GetShortcut());
		rightQS2:SetAllowDrop(false);
		rightQS3:SetShortcut(petQS[petQS7]:GetShortcut());
		rightQS3:SetAllowDrop(false);
		

	elseif (activeCarousel == 1) then

		leftQS1:SetShortcut(cosmeticPetQS[cosmeticQS1]:GetShortcut());
		leftQS1:SetAllowDrop(false);
		leftQS2:SetShortcut(cosmeticPetQS[cosmeticQS2]:GetShortcut());
		leftQS2:SetAllowDrop(false);
		leftQS3:SetShortcut(cosmeticPetQS[cosmeticQS3]:GetShortcut());
		leftQS3:SetAllowDrop(false);
		centerQS:SetShortcut(cosmeticPetQS[cosmeticQS4]:GetShortcut());
		centerQS:SetAllowDrop(false);
		rightQS1:SetShortcut(cosmeticPetQS[cosmeticQS5]:GetShortcut());
		rightQS1:SetAllowDrop(false);
		rightQS2:SetShortcut(cosmeticPetQS[cosmeticQS6]:GetShortcut());
		rightQS2:SetAllowDrop(false);
		rightQS3:SetShortcut(cosmeticPetQS[cosmeticQS7]:GetShortcut());
		rightQS3:SetAllowDrop(false);

	elseif (activeCarousel == 2) then
	
		leftLabel1:SetText(tostring(customQS1+1));
		leftQS1:SetShortcut(customPetQS[customQS1]:GetShortcut());
		leftQS1:SetAllowDrop(true);
		
		leftLabel2:SetText(tostring(customQS2+1));
		leftQS2:SetShortcut(customPetQS[customQS2]:GetShortcut());
		leftQS2:SetAllowDrop(true);
		
		leftLabel3:SetText(tostring(customQS3+1));
		leftQS3:SetShortcut(customPetQS[customQS3]:GetShortcut());
		leftQS3:SetAllowDrop(true);
		
		
		centerLabel:SetText(tostring(customQS4+1));
		centerQS:SetShortcut(customPetQS[customQS4]:GetShortcut());
		centerQS:SetAllowDrop(true);
		
		rightLabel1:SetText(tostring(customQS5+1));
		rightQS1:SetShortcut(customPetQS[customQS5]:GetShortcut());
		rightQS1:SetAllowDrop(true);
		
		rightLabel2:SetText(tostring(customQS6+1));
		rightQS2:SetShortcut(customPetQS[customQS6]:GetShortcut());
		rightQS2:SetAllowDrop(true);
		
		rightLabel3:SetText(tostring(customQS7+1));
		rightQS3:SetShortcut(customPetQS[customQS7]:GetShortcut());
		rightQS3:SetAllowDrop(true);
		
	end

end

LoadShortcuts();

if ( settings.welcome == false ) then
	Turbine.Shell.WriteLine(" ~~~ Willkommen beim Pferdespielzeug ~~~\n - Zum anzeigen der Hilfe gib /ps hilfe an");
end

PferdespielzeugCommand = Turbine.ShellCommand();

function PferdespielzeugCommand:Execute( command, arguments )

	if ( arguments == "hilfe" ) then
		Turbine.Shell.WriteLine(" ~~~ Pferdespielzeug ~~~\n\n - Mit dem Mausrad durch alle Pferde scrollen.\n - Rechtsklicken zum umschalten zwischen Standard oder Systemseitiger vorgabe.\n - Mit dem Kreuz wird das Pferd entlassen.\n - Zum verstecken rechtklicken.\n - Benutze das Kommando '/ps' or '/Pferdespielzeug' zum anzeigen oder verstecken des Plugin.\n - Benutze das Kommando '/ps ruecksetzen' um das Fenster zur Ursprungsposition zurückzuschieben.\n - Benutze das Kommando '/ps willkommenaus' zum ausschalten des Willkommensnachricht.\n - Benutze das Kommando '/ps willkommenan' zum aktivieren der Willkommensnachricht.");
	elseif ( arguments == "willkommenaus" ) then
		settings.welcome = true;
		SaveSettings();
		Turbine.Shell.WriteLine("Willkommensinfos sind nun aus");
	elseif (arguments == "willkommenan" ) then
		settings.welcome = false;
		SaveSettings();
		Turbine.Shell.WriteLine("Willkomensinfos sind nun da");
	elseif ( arguments == "ruecksetzen" ) then
		settings.positionX = ( Turbine.UI.Display.GetWidth() - mainWindow:GetWidth() - edgePadding);		
		settings.positionY = ( Turbine.UI.Display.GetHeight() - mainWindow:GetHeight() - edgePadding * 1.5 );
		mainWindow:SetPosition(settings.positionX, settings.positionY);
		SaveSettings();
		Turbine.Shell.WriteLine("Position resettet");
	elseif ( arguments ~= nil ) then
		mainWindow:SetVisible( not mainWindow:IsVisible() );
	end

end

Turbine.Shell.AddCommand( "ps;Pferdespielzeug", PferdespielzeugCommand );

mainWindow.MouseEnter = function( sender, args )

	if (alwaysHide == false) then
		mainWindow:SetOpacity( 0.75 );
	end

	rightWindow1:SetOpacity( 0.75 );
	rightWindow2:SetOpacity( 0.75 );
	rightWindow3:SetOpacity( 0.75 );
	leftWindow1:SetOpacity( 0.75 );
	leftWindow2:SetOpacity( 0.75 );
	leftWindow3:SetOpacity( 0.75 );
	releaseWindow:SetOpacity( 0.75 );

end

mainWindow.MouseLeave = function( sender, args )

	local X, Y = mainWindow:GetPosition();

	if (alwaysHide == false) then
		mainWindow:SetOpacity( 0 );
	end

	rightWindow1:SetOpacity( 0.25 );
	rightWindow2:SetOpacity( 0.25 );
	rightWindow3:SetOpacity( 0.25 );
	leftWindow1:SetOpacity( 0.25 );
	leftWindow2:SetOpacity( 0.25 );
	leftWindow3:SetOpacity( 0.25 );
	releaseWindow:SetOpacity( 0.25 );

	if ( X ~= settings.positionX or Y ~= settings.positionY ) then
			
		settings.positionX = X;
		settings.positionY = Y;
		SaveSettings();
		
			
	end

end


releaseQS.MouseEnter = function (sender, args)

	releaseButtonLabel:SetBackground( "GlafriasPlugins/Pferdespielzeug/Resources/x_glow.tga" );

end

releaseQS.MouseLeave = function (sender, args)

	releaseButtonLabel:SetBackground( "GlafriasPlugins/Pferdespielzeug/Resources/x.tga" );

end

alwaysHide = settings.alwaysHide;

mainWindow.MouseClick = function (sender, args)

	if ( args.Button == Turbine.UI.MouseButton.Right ) then

		if (alwaysHide == false ) then
			mainWindow:SetOpacity ( 0 );
			alwaysHide = true;
		else
			mainWindow:SetOpacity( 0.75 );
			alwaysHide = false;
		end
		
		settings.alwaysHide = alwaysHide;
		SaveSettings();

	end

end

drag = false;

leftQS1.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

leftQS1.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS1);

end

leftQS1.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS1);
	
end

leftQS1.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

leftQS2.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

leftQS2.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS1);

end

leftQS2.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS1);
	
end

leftQS2.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

leftQS3.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

leftQS3.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS1);

end

leftQS3.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS1);
	
end

leftQS3.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

centerQS.MouseClick = function (sender, args)

	if ( args.Button == Turbine.UI.MouseButton.Right ) then
		
		if (activeCarousel == 0) then

			activeCarousel = 1;
			LoadShortcuts();

		elseif (activeCarousel == 1) then
		
			activeCarousel = 2;
			LoadShortcuts();
		
		elseif (activeCarousel == 2) then

			activeCarousel = 0;
			LoadShortcuts();

		end
		
		settings.activeCarousel = activeCarousel;
		
		SaveSettings();

	end

end

centerQS.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

centerQS.MouseLeave = function(sender, args)

	CheckChanges();

end

centerQS.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS2);

end

centerQS.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS2);
	
end

centerQS.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

rightQS1.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

rightQS1.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS1);

end

rightQS1.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS1);
	
end

rightQS1.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

rightQS2.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

rightQS2.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS2);

end

rightQS2.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS2);
	
end

rightQS2.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

rightQS3.MouseWheel = function(sender, args)

	Carousel(args.Direction);

end

rightQS3.DragDrop = function(sender, args)
	
	ChangeShortcut(sender, customQS3);

end

rightQS3.DragLeave = function(sender, args)

	RemoveShortcut(sender, customQS3);
	
end

rightQS3.MouseDown = function(sender, args)

	if(args.Button == Turbine.UI.MouseButton.Left) then	
		drag = true;
	end

end

function ChangeShortcut(qs, qsPosition)

	if ((activeCarousel == 2) and (qs:GetShortcut():GetData() ~= settings.customShortcuts[qsPosition].Data)) then

		settings.customShortcuts[qsPosition].Type = qs:GetShortcut():GetType();
		settings.customShortcuts[qsPosition].Data = qs:GetShortcut():GetData();
		customPetQS[qsPosition]:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.customShortcuts[qsPosition].Type, settings.customShortcuts[qsPosition].Data ) );
		SaveSettings();
	
	end

end

function RemoveShortcut(qs, qsPosition)

	if (drag) then
	
		if (activeCarousel == 2) then

			settings.customShortcuts[qsPosition].Type = "nil";
			settings.customShortcuts[qsPosition].Data = "";
			customPetQS[qsPosition]:SetShortcut( Turbine.UI.Lotro.Shortcut( nil, "" ) );
			qs:SetShortcut(customPetQS[qsPosition]:GetShortcut());
			qs:SetAllowDrop(true);
			SaveSettings();
			drag = false;
			
		end
		
	end

end

function Carousel(modifier) -- And yet it moves!

	if (activeCarousel == 0) then

		local total = TableCount(petData);
	
		petQS1 = (petQS1 + modifier) % total;
		petQS2 = (petQS2 + modifier) % total;
		petQS3 = (petQS3 + modifier) % total;
		petQS4 = (petQS4 + modifier) % total;
		petQS5 = (petQS5 + modifier) % total;
		petQS6 = (petQS6 + modifier) % total;
		petQS7 = (petQS7 + modifier) % total;

		LoadShortcuts();

	elseif (activeCarousel == 1) then

		local total = TableCount(cosmeticPetData);
	
		cosmeticQS1 = (cosmeticQS1 + modifier) % total;
		cosmeticQS2 = (cosmeticQS2 + modifier) % total;
		cosmeticQS3 = (cosmeticQS3 + modifier) % total;
		cosmeticQS4 = (cosmeticQS4 + modifier) % total;
		cosmeticQS5 = (cosmeticQS5 + modifier) % total;
		cosmeticQS6 = (cosmeticQS6 + modifier) % total;
		cosmeticQS7 = (cosmeticQS7 + modifier) % total;
		

		LoadShortcuts();
	
	elseif (activeCarousel == 2) then
		
		local total = TableCount(settings.customShortcuts);
		
		customQS1 = (customQS1 + modifier) % total;
		customQS2 = (customQS2 + modifier) % total;
		customQS3 = (customQS3 + modifier) % total;
		customQS4 = (customQS4 + modifier) % total;
		customQS5 = (customQS5 + modifier) % total;
		customQS6 = (customQS6 + modifier) % total;
		customQS7 = (customQS7 + modifier) % total;
	
		LoadShortcuts();
	
	end

end




function CheckChanges()

	if (activeCarousel == 0) and (settings.petQS1 ~= petQS1) then
	
		settings.petQS1 = petQS1;
		settings.petQS2 = petQS2;
		settings.petQS3 = petQS3;
		settings.petQS4 = petQS4;
		settings.petQS5 = petQS5;
		settings.petQS6 = petQS6;
		settings.petQS7 = petQS7;
	
	elseif (activeCarousel == 1) and (settings.cosmeticQS1 ~= cosmeticQS1) then
	
		settings.cosmeticQS1 = cosmeticQS1;
		settings.cosmeticQS2 = cosmeticQS2;
		settings.cosmeticQS3 = cosmeticQS3;
		settings.cosmeticQS4 = cosmeticQS4;
		settings.cosmeticQS5 = cosmeticQS5;
		settings.cosmeticQS6 = cosmeticQS6;
		settings.cosmeticQS7 = cosmeticQS7;
	
	elseif (activeCarousel == 2) and (settings.customQS1 ~= customQS1) then
	
		settings.customQS1 = customQS1;
		settings.customQS2 = customQS2;
		settings.customQS3 = customQS3;
		settings.customQS4 = customQS4;
		settings.customQS5 = customQS5;
		settings.customQS6 = customQS6;
		settings.customQS7 = customQS7;
	
	end

	SaveSettings();

end


	